%bcond_with test

Summary:        A regular expression library for OCaml
Name:           ocaml-re
Version:        1.10.4
Release:        2%{?dist}
License:        LGPL-2.1-or-later WITH OCaml-LGPL-linking-exception
URL:            https://github.com/ocaml/ocaml-re
Source0:        https://github.com/ocaml/%{name}/archive/%{version}/%{name}-%{version}.tar.gz

Patch3000:      %{name}-remove-seq.patch

BuildRequires:  ocaml ocaml-dune

%if %{with test}
BuildRequires:  ocaml-ounit-devel
%endif

%description
A pure OCaml regular expression library. Supports Perl-style regular
expressions, Posix extended regular expressions, Emacs-style regular
expressions, and shell-style file globbing.  It is also possible to build
regular expressions by combining simpler regular expressions.  There is also a
subset of the PCRE interface available in the Re.pcre library.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and signature files for developing
applications that use %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

# Fix the ounit name
sed -i 's/oUnit/ounit2/' lib_test/fort_unit/dune

%build
dune build --verbose --release %{?_smp_mflags}


%install
dune install --destdir=%{buildroot} --verbose --release %{?_smp_mflags}
mlis=$(find %{buildroot}/usr/lib64/ocaml -name '*.mli')
rm -f ${mlis//.mli/.ml}
rm -rf %{buildroot}%{_prefix}/doc

dev_suffixes=("a" "cmo" "cmt" "cmti" "cmx" "cmxa" "h" "idl" "ml" "mli" "o")
touch devel.filelist
for suffix in "${dev_suffixes[@]}"; do
  find %{buildroot} -type f -name "*.${suffix}" -printf '/%%P\n' >> devel.filelist
done

find %{buildroot} -type f \( -name "dune-package" -o -name "opam" \) \
    -printf '/%%P\n' >> devel.filelist

sed 's|^|%exclude |' devel.filelist > main.filelist

%if %{with tests}
%check
dune runtest --verbose --release %{?_smp_mflags}
%endif

%files -f main.filelist
%license LICENSE.md
%doc CHANGES.md
%doc README.md
%{_libdir}/*

%files devel -f devel.filelist

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.10.4-2
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 10 2023 Shuo Wang <abushwang@tencent.com> - 1.10.4-1
- init package

